<?PHP
	// create folder list
	function getfolderlist($mbox, $all=0) {
		$folders = array();
		$folderarr = array();
		if (($all != 0) || ($_SESSION["protocol"] == "pop3")){
			$folderarr = imap_list($mbox, $_SESSION["serverstring"], substr($_SESSION["rootfolderpath"], 0, strrpos($_SESSION["rootfolderpath"], $_SESSION["folderseparator"])) . "*");
		} else {
			$folderarr = imap_lsub($mbox, $_SESSION["serverstring"], $_SESSION["rootfolderpath"] . "*");
		}
		if (is_array($folderarr)) {
			$folderarr = array_values(array_unique($folderarr));
			sort($folderarr);
		} else {
			$folderarr = array(0=>$folderarr);
		}

		// Now we want to prepend our INBOX if there is a rootfolderpath (but only if it's imap).
		if (($_SESSION["rootfolderpath"] != "") && ($_SESSION["protocol"] == "imap")) {
			$inbox = imap_lsub($mbox, $_SESSION["serverstring"],  substr($_SESSION["rootfolderpath"], 0, strrpos($_SESSION["rootfolderpath"], $_SESSION["folderseparator"])));
			// If it's subscribed, add it to the rest of the subscribed folders
			if (count($inbox) == 1) {
				if (count($folderarr) == 0) {
					$folderarr = $inbox;
				} else {
					array_unshift($folderarr, $inbox[0]);
				}
			}
		}

		reset($folderarr);
		for ($i = 0; $i < count($folderarr); $i++) {
			$index = count($folders);
			$name = getmailboxname($folderarr[$i]);
			if ($i > 0) {
				if (($name[0] > $folders[$i - 1]["level"]) && ($i > 1)){
					$temp = str_replace($_SESSION["serverstring"] . $_SESSION["rootfolderpath"], "", $folderarr[$i]);
					$currfolder = explode($_SESSION["folderseparator"], $temp);
					$temp = str_replace($_SESSION["serverstring"] . $_SESSION["rootfolderpath"], "", $folderarr[$i - 1]);
					$lastfolder = explode($_SESSION["folderseparator"], $temp);
					for ($j = 0; $j < count($currfolder) - 1; $j++) {
						if ($currfolder[$j] != $lastfolder[$j]) {
							$folders[$index]["folder"] = "";
							$folders[$index]["name"] = $currfolder[$j];
							$folders[$index]["level"] = $j + 1;
							$index++;
						}
					}
				}
			}
			$folders[$index]["folder"] = $folderarr[$i];
			$folders[$index]["name"] = $name[1];
			$folders[$index]["level"] = $name[0];
		}
		return $folders;
	}

	// takes a folder name and returns a cleaned-up version and the indenting depth
	function getmailboxname($mname) {
		// Strip off the server and root folder bits.
		$mname = substr($mname, strlen($_SESSION["serverstring"]));
		$mname = substr($mname, strlen($_SESSION["rootfolderpath"]));

		// if nothing is left, it's the Inbox, return that
		if ($mname == "") {
			return array(1, "Inbox");
		}

		// go through each separator until none are left, indenting each time
		$depth = 1;
		$pos = strpos($mname, $_SESSION["folderseparator"]);
		while ($pos) {
			$mname = substr($mname,$pos+1);
			$pos = strpos($mname,$_SESSION["folderseparator"]);
			$depth++;
		}

		return array($depth, $mname);
	}


	// helper function from striphtml that replaces tags appropriately
	function replacetag($tag)
	{
		$tag = trim(strtolower($tag[0]));
		if($tag == '<br>' or $tag == '<br/>' or $tag == '<br />' or $tag == '</div>' or $tag == '</p>') {
			return "\n";
		} else if ($tag == '<b>' or $tag == '</b>' or $tag == '<strong>' or $tag == '</strong>') {
			return '*';
		} else if ($tag == '<i>' or $tag == '</i>' or $tag == '<em>' or $tag == '</em>') {
			return '-';
		} else if ($tag == '&nbsp;') {
			return ' ';
		} else if ($tag == '&amp;') {
			return '&';
		} else if ($tag == '&gt;') {
			return '>';
		} else if ($tag == '&lt;') {
			return '<';
		} else {
			return "";
		}
	}


	// strips all html tags from an email
	function striphtml($str)
	{
		// strip out things between style and script tags
		$str = preg_replace("/<\s*style[^>]*>.*<\/style>/si", "", $str);
		$str = preg_replace("/<\s*script[^>]*>.*<\/script>/si", "", $str);
		$str = preg_replace("/<!--.*-->/si", "", $str);

		// clean out most tags and special entities
		return trim(preg_replace_callback("/(<\s*(?:\"[^\"]*\"|'[^']*'|[^'\">])*>|&nbsp;|&amp;|&gt;|&lt|\r\n|\n|\r;)/", "replacetag", $str));
	}


        // trims out the body of an HTML message
        function getHTMLBody($body)
        {
                // We want to ditch everything up to and including the opening body tag, as well as every past and including the body closing tag
		$body = preg_replace("/.*<body( [^>]*)?>/ims", "", $body);
		$body = preg_replace("/<\/body( [^>]*)?>.*/ims", "", $body);

		// strip out the script tags if we are supposed to
		if ($_SESSION["stripscripttags"] == 1) {
			$body = preg_replace("/<\s*script[^>]*>.*<\s*\/script\s[^>]*>/si", "", $body);
		}
		return $body;
        }


	// returns the text for a mailto link given a user and domain
	function makeMailLink($address)
	{
		$link = "<A HREF=\"#n\" OnClick=\"window.open('sendmail.php?toaddress=" . urlencode($address) . "', '', 'width=640,height=480,toolbars=no,scrollbars=no');\">" . $address . "</A>";
		return $link;
	}


	// alters <A> tags so that all targets point to _blank
	function fixAnchor($tag)
	{
		// is there already a target?
		if ($_SESSION["linknewwindow"] == 1) {
			if(preg_match("/ target[ ]*=[ ]*([^ >]*)/i", $tag[0]) > 0) {
				$tag = preg_replace("/ target[ ]*=[ ]*([^ >]*)/i", " target=\"_blank\"", $tag[0]);
			}
			else {
				// there is no target - let's add one
				$tag = preg_replace("/<a /i", "<a target=\"_blank\" ", $tag[0]);
			}
		} else {
			if(preg_match("/ target[ ]*=[ ]*([^ >]*)/i", $tag[0]) > 0) {
				$tag = preg_replace("/ target[ ]*=[ ]*([^ >]*)/i", "", $tag[0]);
			}
			else {
				// there is no target - let's add one
				$tag = preg_replace("/<a /i", "<a ", $tag[0]);
			}
		}
		return $tag;
	}


        // prints the main part of the message
        function printText(&$body, $type, $subtype, $encoding, $isreply)
        {
		$msgbody = "";

		if($encoding == 0 || $encoding == 1) {
			// normal text do nothing
		} else if ($encoding == 3) {
			// decode base64 body
			$body = imap_base64($body);
		} else if ($encoding == 4) {
			// decode quoted printable body
			$body = quoted_printable_decode($body);
		}

		if($subtype == "HTML") {
			// clean up HTML for displaying within an HTML page
			if($isreply)
				$msgbody = "> " . str_replace("\n", "\n> ", striphtml(getHTMLBody($body)));
			else
				$msgbody = getHTMLBody($body);
		} else {
			if($isreply)
				$msgbody = "> " . str_replace("\n", "\n> ", $body);
			else
				$msgbody = nl2br(str_replace("  ", "&nbsp;&nbsp; ", htmlspecialchars($body)));
		}

		// if this is reply text just return it
		// if it is HTML replace <A> tag targets with _blank
		// otherwise hyperlink web addresses and email addresses in the text
		if($isreply) {
			return $msgbody;
		} else if ($subtype == "HTML") {
			// replace any hyperlinks with local targets with a target _blank so they popup in nice new windows
			$msgbody = preg_replace_callback("/<a[^>]*>/i", "fixAnchor", $msgbody);

			return $msgbody;
		} else {
			// replace plain URL's with hyperlinked URL's
			if ($_SESSION["linknewwindow"] == 1) {
				$msgbody = preg_replace("/(http|ftp|https):\/\/[\w]+(.[\w]+)([\w\-\.,@?^=%&:;\/~\+#]*[\w\-\@?^=%&\/~\+#])?/i","<a href=\"\\0\" target=\"_blank\">\\0</a>",$msgbody);
				//$msgbody = preg_replace("/\b(http(s)?:\/\/|(www\.))([-\w\.\/]+)(\?[\w,\.*%;-]+=[\w,\.*%;-]+(?:&[\w,\.*%;-]+=[\w,\.*%;-])*)?\b/", "<a href=\"http$2://$3$4$5\" target=\"_blank\">$1$4$5</a>$6", $msgbody);
			} else {
				$msgbody = preg_replace("/(http|ftp|https):\/\/[\w]+(.[\w]+)([\w\-\.,@?^=%&:;\/~\+#]*[\w\-\@?^=%&\/~\+#])?/i","<a href=\"\\0\">\\0</a>",$msgbody);
				//$msgbody = preg_replace("/\b(http(s)?:\/\/|(www\.))([-\w\.\/]+)(\?[\w,\.*%;-]+=[\w,\.*%;-]+(?:&[\w,\.*%;-]+=[\w,\.*%;-])*)?\b/", "<a href=\"http$2://$3$4$5\">$1$4$5</a>$6", $msgbody);
			}
			// replace email addresses with hyperlinked email addresses
			$msgbody = preg_replace("/([\d\w\.-]+)(@)([\d\w\.-]+)\b/ei", "makeMailLink(\"$0\")", $msgbody);

			return $msgbody;
		}
	}

	// decodes attachments and saves them to disk
	function decode($mbox, $part, $encoding, $name)
	{
		// open the file
		$fp = fopen($name, "w");

		if($encoding == 3) {
			fwrite($fp, imap_base64(imap_fetchbody($mbox, $_SESSION["currentmessage"], $part, FT_UID + FT_PEEK)));
		} else if ($encoding == 4) {
			fwrite($fp, imap_qprint(imap_fetchbody($mbox, $_SESSION["currentmessage"], $part, FT_UID + FT_PEEK)));
		} else {
			fwrite($fp, imap_fetchbody($mbox, $_SESSION["currentmessage"], $part, FT_UID + FT_PEEK));
		}

		fclose($fp);
	}

	// Decodes an alternative type according to user settings
	function printAlternativePart($mbox, $part, $partnumber, $isreply=0) {
		$parthash = array();
		for($i = 0; $i < count($part->parts); $i++) {
			$parthash[$part->parts[$i]->subtype] = $i;
		}
		if (isset($parthash["HTML"])) {
			$parttorender = $parthash["HTML"];
		} else {
			$parttorender = $parthash["PLAIN"];
		}
		$body = imap_fetchbody($mbox, $_SESSION["currentmessage"], $partnumber . ($parttorender + 1), FT_PEEK + FT_UID);
		$type = $part->parts[$parttorender]->type;
		$subtype = $part->parts[$parttorender]->subtype;
		$encoding = $part->parts[$parttorender]->encoding;
		return printText($body, $type, $subtype, $encoding, $isreply);
	}

	// This will increment a partnumber in a sane way
	function newPartNumber($oldpartnumber, $amount=1) {
		if ($oldpartnumber === false) {
			return $amount;
		} else {
			$pos = strrpos($oldpartnumber, ".");
			if ($pos === false) {
				$newpartnumber = $oldpartnumber;
			} else {
				$newpartnumber = substr($oldpartnumber, 0, $pos) . "." . (substr($oldpartnumber, $pos+1) + $amount);
			}
			return $newpartnumber;
		}
	}

	// Decodes a part of an e-mail and displays it in the proper way, recursing if needed
	function printPart($mbox, $message, $part, $partnumber, $isreply=0) {
		$newpartnumber = newPartNumber($partnumber);
		// if it's a text part, just decode the text
		if (($part->type == 0) && ((!isset($part->disposition)) || (strtolower($part->disposition) != "attachment"))) {
			$body = imap_fetchbody($mbox, $_SESSION["currentmessage"], $newpartnumber, FT_PEEK + FT_UID);
			$message["body"] .= printText($body, $part->type, $part->subtype, $part->encoding, $isreply);
		// if it's an embedded alternative encoding, print that
		} else if (strtolower($part->subtype) == "alternative") {
			if ($partnumber == "") {
				$message["body"] .= printAlternativePart($mbox, $part, "", $isreply);
			} else {
				$message["body"] .= printAlternativePart($mbox, $part, $partnumber . ".", $isreply);
			}
		// If it's an rfc attachment, send it to print part specifically
		} else if ($part->subtype == "RFC822") {
			//echo(imap_fetchbody($mbox, $_SESSION["currentmessage"], "3", FT_PEEK + FT_UID));
			$message = printPart($mbox, $message, $part->parts[0], $newpartnumber, $isreply);
		// if it's multipart, print out all the bits
		} else if (isset($part->parts) && count($part->parts) > 0 && $part->subtype) {
			for($i=0; $i<count($part->parts); $i++) {
				if ($partnumber === false) {
					$message = printPart($mbox, $message, $part->parts[$i], $i + 1, $isreply);
				} else {
					$message = printPart($mbox, $message, $part->parts[$i], $newpartnumber . "." .  $i, $isreply);
				}
			}
		// otherwise, it's probably an attachment. decode
		} else {
			if (GetTextType($part->type) == "") {
				$mimetype = "No type";
			} else {
				$mimetype = ucwords(GetTextType($part->type) . "/" . strtolower($part->subtype));
			}
			$name = "Attachment_" . $newpartnumber . "." . strtolower($part->subtype);
			if (isset($part->dparameters)) {
				$arr = $part->dparameters;
				if (strtolower($arr[0]->attribute) == "filename") {
					$name = $arr[0]->value;
				}
			} else if (isset($part->parameters)) {
				$arr = $part->parameters;
				for($c=0;$c<count($arr);$c++) {
					$param = $arr[$c];
					if(strtolower($param->attribute) == "name") {
						$name = $param->value;
					}
				}
			}
			// decode and write the file to disk if it's allowed
			$filearr = explode(".", $name);
			$temp = $filearr[0];
			unset($filearr[0]);
			if (count(array_intersect($filearr, $_SESSION["extensionblacklist"])) > 0) {
				$name = $temp . "_" . implode("_", $filearr) . ".disallowed_extension";
			}

			$name = ISDecode(addslashes($name));
			if ($name == "") {
				$name = "Attachment_" . $newpartnumber;
			}
			if ($isreply == 0) {
				decode($mbox, $newpartnumber, $part->encoding, ("users/" . md5($_SESSION["emailaddress"]) . "/attachments/" . $name));
			} else {
				decode($mbox, $newpartnumber, $part->encoding, ("users/" . md5($_SESSION["emailaddress"]) . "/fattachments/" . $name));
			}

			// set up the link
			// if it's an image display it in the page
			if ($isreply == 0) {
				if (($part->type == 5) && (strtolower($mimetype) != "image/tiff")){
					$message["body"] .= "<img class=\"imgattachment\" src=\"users/" . md5($_SESSION["emailaddress"]) . "/attachments/" . rawurlencode($name) . "\"/><br/>\n";
				} else {
					$message["body"] .= "<p class=\"fileattachment\"><a href=\"users/" . md5($_SESSION["emailaddress"]) . "/attachments/" . rawurlencode($name) . "\">" . $name . " (" . $mimetype . ")</a> <span>(" . filesize("./users/" . md5($_SESSION["emailaddress"]) . "/attachments/" . $name) . " bytes)</span></p>\n";
				}
			}
			$message["attachments"][count($message["attachments"])] = $name;
		}
		return $message;
	}

	 // cleans up a message body and prints it in a pretty way
	function printBody($mbox, $isreply=0) {
		$message = array();
		$message["body"] = "";
		$message["attachments"] = array();

		// get the structure of the message
		$structure = @imap_fetchstructure($mbox, imap_msgno($mbox, $_SESSION["currentmessage"]));
		if(!$structure and !$isreply) {
			$message["body"] .= "<div id=\"nomessage\">" . gettext("Unable to retrieve message from server") . "</div>\n";
			return $message;
		}

		// Reset the attachments directories
		if ($isreply == 0) {
			rmdir_rf("users/" . md5($_SESSION["emailaddress"]) . "/attachments");
			mkdir_p("users/" . md5($_SESSION["emailaddress"]) . "/attachments");
		} else {
			rmdir_rf("users/" . md5($_SESSION["emailaddress"]) . "/fattachments");
			mkdir_p("users/" . md5($_SESSION["emailaddress"]) . "/fattachments");
		}

		$message = printPart($mbox, $message, $structure, false, $isreply);

		// Remember, we need to properly decode any strange characterset that might be hiding in the header
		// so lets bring out the headers and do some searching.
		$headers = @imap_fetchheader($mbox, imap_msgno($mbox, $_SESSION["currentmessage"]));
		
		// Apply a character conversion if iconv is installed and it's necessary
		if (($headers !== FALSE) && function_exists("iconv")) {
			// Next, lets dig after a Content-Type
			$contenttype = stristr($headers, "content-type:");
			if ($contenttype !== FALSE) {
				// Okay, time to look for the elusive charset= part
				// it might be on the first line, but could also hide in the second, so we try both
				// (the third line keeps the remainder, don't want to pickup strays)
				$lines = explode("\n", $contenttype, 3);
				$charset = "";
				for ($iC = 0; $iC < 2; $iC++) {
					if (eregi('charset="{0,1}([A-Za-z0-9\-]+)', $lines[$iC], $result)) {
						$charset = strtolower($result[1]);
						break;
					}
				}

				// Apply conversion if needed
				if ($charset != "" && $charset != "iso-8859-1") {
					$tmp = iconv($charset, "ISO-8859-1", $message["body"]);
					
					// Sanitycheck, maybe someone is lying about their actual charset?
					// Don't replace the body when the amount of changes is bigger than
					// 10% in textsize.
					//
					// Should probably do this better somehow, but this is fairly foolproof.
					//
					if (abs(strlen($message["body"]) - strlen($tmp)) < (strlen($message["body"])*0.1))
						$message["body"] = $tmp;
				}
			}
		}
		return $message;
        }
	
	function DeleteMessages($mbox, $messagelist) {
		imap_setflag_full($mbox,$messagelist,'\\SEEN', ST_UID);
		imap_delete($mbox, $messagelist, FT_UID);
		imap_expunge($mbox);
	}

	function SendReadConfirmation($mbox, $to, $from, $subject, $messageid, $date) {
		$envelope = array();
		if ($_SESSION["replyto"] != "") {
			$envelope["reply_to"] = $_SESSION["replyto"];
		} else {
			$envelope["reply_to"] = $_SESSION["emailaddress"];
		}
		$envelope["return_path"] = $_SESSION["emailaddress"];
		$envelope["to"] = $to;
		$envelope["subject"] = "Read: " . $subject;
		$envelope["date"] = date("r");
		$envelope["custom_headers"] = Array("X-Mailer-Version: " . $ismailversion, "X-Mailer: ISMail (http://www.insidesystems.net/projects/project.php?projectid=4)");
		$envelope["message_id"] = "<" . str_replace(" ", ".", microtime()) . "@" . $_SESSION["domain"] . ">";
		$envelope["in_reply_to"] = $messageid;
		$envelope["custom_headers"][count($envelope["custom_headers"])] = "References: " . $messageid;

		$body = array();
		$body[0] = array();
		$body[0]["type"] = TYPETEXT;
		$body[0]["subtype"] = "plain";
		$body[0]["description"] = "messagebody";
		$body[0]["contents.data"] = gettext("This is a receipt for the mail you sent to") . " <" . $from . "> " . gettext("at") . " " . $date . ".\n\n";
		$body[0]["contents.data"] .= gettext("This receipt verifies that the message has been displayed on the recipient's computer at") . " " . date("r") . ".";

		// send it
		if ($_SESSION["displayname"] == "") {
			$email = "From: \"" . addslashes($_SESSION["emailaddress"]) . "\" <" . $_SESSION["emailaddress"] . ">\n" . imap_mail_compose($envelope, $body);
		} else {
			$email = "From: \"" . addslashes($_SESSION["displayname"]) . "\" <" . $_SESSION["emailaddress"] . ">\n" . imap_mail_compose($envelope, $body);
		}
		$fp = popen($_SESSION['mailprogram'], "w");
		fwrite($fp, $email);
		pclose($fp);

		// Stick a copy in the sent items and mark the current message as read.
		imap_setflag_full($mbox,$_SESSION["currentmessage"],'\\SEEN', ST_UID);
		$sentitems = open_mailbox($_SESSION["serverstring"] . $_SESSION["rootfolderpath"] . $_SESSION["sentfoldername"]);
		imap_append($sentitems, $_SESSION["serverstring"] . $_SESSION["rootfolderpath"] . $_SESSION["sentfoldername"], $email);
		$status = imap_check($sentitems);
		// We don't use UID's here so we can just mark the last one put in there as seen
		imap_setflag_full($sentitems, $status->Nmsgs,'\\SEEN');
		imap_close($sentitems);
	}
	
	// Takes a type as a number from imap functions and returns it's type in text
	function GetTextType($type) {
		switch($type) {
			case "0":
				return "text";
				break;
			case "1":
				return "multipart";
				break;
			case "2":
				return "message";
				break;
			case "3":
				return "application";
				break;
			case "4":
				return "audio";
				break;
			case "5":
				return "image";
				break;
			case "6":
				return "video";
			case "7":
				return "other";
				break;
			default:
				return false;
		}
	}

	// Takes an encoding as a number from imap functions and returns the text
	function GetTextEncoding($encoding) {
		switch($encoding) {
			case "0":
				return "7bit";
				break;
			case "1":
				return "8bit";
				break;
			case "2":
				return "binary";
				break;
			case "3":
				return "base6464";
				break;
			case "4":
				return "quoted-printable";
				break;
			case "5":
				return "other";
				break;
			default:
				return false;
		}
	}
	
	// This is a wrapper function for imap_createmailbox that will not attempt to create a mailbox if it already exists
	function is_createmailbox($mbox, $name) {
		// Get all mailboxes, not just subscribed ones
		$list = imap_getmailboxes($mbox, $_SESSION["serverstring"], "*");

		if (is_array($list)) {
			reset($list);
			while (list($key, $val) = each($list)) {
				if (imap_utf7_decode($val->name) == $name) {
					return true;
				}
			}
		}
		
		return imap_createmailbox($mbox, $name);
	}

?>
