<?PHP
	include "include/globals.php";
	include "include/mailfunctions.php";

	if (isset($_REQUEST["newmessage"])) {
		$_SESSION["currentmessage"] = $_REQUEST["newmessage"];
	} else {
		$_SESSION["currentmessage"] = -1;
	}
	// exit if no message has been chosen yet
	if(($_SESSION["currentfolder"] != "") and ($_SESSION["currentmessage"] != "") and ($_SESSION["currentmessage"] != -1)) {
		$mbox = open_mailbox($_SESSION["currentfolder"]);

		// get the header information
		$headerinfo = @imap_header($mbox, imap_msgno($mbox, $_SESSION["currentmessage"]), 50, 50);

		// Now we have to get the full header to support the organization header
		$rawheader = @imap_fetchheader($mbox, $_SESSION["currentmessage"], FT_UID);
		preg_match("/Organization:(.+)\n/", $rawheader, $match);
		$organization = "";
		if (isset($match[1]) && ($match[1] != "")) {
			$organization = trim($match[1]);
		}
	} else {
		$blank = 1;
	}

	function format_address($address) {
		// if it has a part in <> brackets, remove it
		$address = preg_replace("/\<[^\>]*\>/", "", $address);
		// Get rid of any kinds of quotes that are in it.
		$address = str_replace("\"", "", $address);
		$address = ISDecode($address);
		return htmlspecialchars($address);
	}

	PageHeader(1);
?>
<head>
	<title></title>
	<style type="text/css">
		@import "themes/<?php echo($_SESSION["themedir"]);?>/css/mail.css";
	</style>
	<script type="text/Javascript">
		<!--
<?php
	if (!isset($blank)) {
		$tostr = "";
		echo("		parent.parent.mailheader.document.getElementById('headers').style.visibility = 'visible';\n");
		echo("		parent.parent.mailheader.document.getElementById('headerlinks').style.visibility = 'visible';\n");
		if (isset($headerinfo->toaddress)) {
			$tostr = format_address($headerinfo->toaddress);
		}
		if(strlen($tostr) > 50) {
			$tostr = substr($tostr,0,(int)strrpos(substr($tostr,0,50), ' ')) . "...";
		}
		echo("		parent.parent.mailheader.document.getElementById('frombit').firstChild.nodeValue = '" . format_address($headerinfo->fromaddress) . "';\n");
		if ($organization != "") {
			$organization = preg_replace("/\b((http(s?):\/\/)|(www\.))([\w\.]+)([\/\w+\.\?\=\-\&\;]+)\b/i", "<a href=\"http$3://$4$5$6\" target=\"_blank\">$2$4$5$6</a>", $organization);
			$tostr .= "  (" . $organization . ")";
		}
		echo("		parent.parent.mailheader.document.getElementById('tobit').firstChild.nodeValue = '" . addslashes($tostr) . "';\n");
		if (isset($headerinfo->subject) && ($headerinfo->subject != "")) {
			echo("		parent.parent.mailheader.document.getElementById('subjectbit').firstChild.nodeValue = '" . addslashes(ISDecode($headerinfo->subject)) . "';\n");
		} else {
			echo("		parent.parent.mailheader.document.getElementById('subjectbit').firstChild.nodeValue = '(No Subject)';\n");
		}
		if ($_SESSION['dictenable'] == 1) {
			echo("		function defineWord(word) {\n");
			echo("			window.open('dict.php?word=' + word,'','width=650,height=480,toolbars=no,scrollbars=yes');\n");
			echo("		}\n");
			echo("		function GetWord() {\n");
			echo("			if (document.getSelection) {\n");
			echo("				var text = document.getSelection();\n");
			echo("			} else if (document.selection) {\n");
			echo("				var text = document.selection.createRange().text;\n");
			echo("			} else {\n");
			echo("				return;\n");
			echo("			}\n");
			echo("			defineWord(text);\n");
			echo("		}\n");
		}

		// Test to see if we are to deliver a confirmation of some sort
		if (isset($_POST["sendreceipt"])) {
			$headerinfo = @imap_header($mbox, imap_msgno($mbox, $_SESSION["currentmessage"]), 50, 50);
			SendReadConfirmation($mbox, $headerinfo->fromaddress, $headerinfo->toaddress, $headerinfo->subject, $headerinfo->message_id, date("n/j/Y g:i A", strtotime($headerinfo->date)));
		} else if (isset($_POST["noreceipt"])) {
			imap_setflag_full($mbox,$_SESSION["currentmessage"],'\\SEEN', ST_UID);
		} else if (($_SESSION["confirmdelivery"] != "never") && (!isset($_POST["noreceipt"]))){
			// Now check if this has been seen. If seen, don't bother. If not, check to send a receipt.
			$headerinfo = @imap_header($mbox, imap_msgno($mbox, $_SESSION["currentmessage"]), 50, 50);
			if (($headerinfo->Unseen == "U") || ($headerinfo->Recent == "N")) {
				// Since it's been seen, we must send receipts.
				$fullheader = imap_fetchheader($mbox, $_SESSION["currentmessage"], FT_UID);
				preg_match("/\nDisposition-Notification-To:(.*)\n/i", $fullheader, $match);
				// If there is a Disposition-Notification-To header, check to see if we send it automatically
				if (count($match) > 0) {
					if (($match[1] != "") && ($_SESSION["confirmdelivery"] == "always")) {
						SendReadConfirmation($mbox, $headerinfo->fromaddress, $headerinfo->toaddress, $headerinfo->subject, $headerinfo->message_id, date("n/j/Y g:i A", strtotime($headerinfo->date)));
					} else if (($match[1] != "") && ($_SESSION["confirmdelivery"] == "ask")) {
						$confirmreceipt = 1;
					}
				}
			}
		}
	} else {
		echo("		parent.parent.mailheader.document.getElementById('headers').style.visibility = 'hidden';\n");
		echo("		parent.parent.mailheader.document.getElementById('headerlinks').style.visibility = 'hidden';\n");
		echo("		parent.parent.mailheader.document.getElementById('frombit').firstChild.nodeValue = '';\n");
		echo("		parent.parent.mailheader.document.getElementById('tobit').firstChild.nodeValue = '';\n");
		echo("		parent.parent.mailheader.document.getElementById('subjectbit').firstChild.nodeValue = '';\n");
	}
?>
		// -->
	</script>
</head>
<body>
<?php
	if (isset($confirmreceipt) and !isset($blank)) {
		echo("<div id=\"confirmreceipt\">\n");
		echo("	<form id=\"confirmreceiptform\" method=\"post\" action=\"mail.php\">\n");
		echo("		<input id=\"newmessage\" type=\"hidden\" name=\"newmessage\" value=\"" . $_SESSION["currentmessage"]  . "\"/>\n");
		echo("		<span>" . gettext("The sender of this e-mail has requested a receipt indicating that you have read it. Do you wish to send one?") . "</span><br/>\n");
		echo("		<input id=\"sendreceipt\" type=\"submit\" name=\"sendreceipt\" value=\"" . gettext("Yes") . " \"/>\n");
		echo("		<input id=\"noreceipt\" type=\"submit\" name=\"noreceipt\" value=\"" . gettext("No") . " \">\n");
		echo("	</form>\n");
		echo("</div>\n");
	}
	if (!isset($blank)) {
		if ($_SESSION['dictenable'] == 1) {
			echo("<div id=\"messagebody\" ondblclick=\"GetWord();\">\n");
		} else {
			echo("<div id=\"messagebody\">\n");
		}
		$message = printBody($mbox);
		echo($message["body"]);
		echo("</div>\n");
	}
?>
</body>
<?php
	if (!isset($blank)) {
		// clear the errors and close the connection
		imap_errors();
		imap_close($mbox);
	}
?>
</html>
